import java.io.*;
import java.util.*;
import java.text.*;

public class Atlantis {
    public static void main(String[] args) {
	try {
	    StreamTokenizer st = 
		new StreamTokenizer(new BufferedReader(
		     new FileReader("atlantis.in")));
	    BufferedWriter writer =
		new BufferedWriter(new FileWriter("atlantis.out"));
	    DecimalFormat df = new DecimalFormat("0.00");

	    int n, i, j, case_id = 0;
	    while (true) {
		case_id++;
		st.nextToken();
		n = (int)st.nval;
		if (n == 0)
		    break;

		System.out.println(n);
		XList xlist = new XList();
		for (i = 0; i < n; i++) {
		    double x1, x2, y1, y2;
		    st.nextToken();
		    x1 = st.nval;
		    st.nextToken();
		    y1 = st.nval;
		    st.nextToken();
		    x2 = st.nval;
		    st.nextToken();
		    y2 = st.nval;

		    xlist.add(x1, x2, y1, y2);
		}
		writer.write("Test case #" + case_id + "\n");
		writer.write("Total explored area: " + 
			     df.format(xlist.calc()) + "\n\n");
		writer.flush();
	    }
	} catch (IOException e) {
	    System.err.println("IO Error");
	}
    }
}

class YListElement implements Comparable{
    public double y;
    public int flag;
    YListElement(double y, int flag) {
	this.y = y;
	this.flag = flag;
    }
    public int compareTo(Object o) {
	if (this.y < ((YListElement)o).y - 0.00001)
	    return -1;
	else if (this.y > ((YListElement)o).y + 0.00001)
	    return 1;
	else 
	    return 0;
    }
}

class XListElement {
    public double x1, x2;
    ArrayList list = new ArrayList();
    XListElement(double x1, double x2) {
	this.x1 = x1;
	this.x2 = x2;
    }
    XListElement(double x1, double x2, double y1, double y2) {
	this(x1, x2);
	add(y1, y2);
    }
    public void add(double y1, double y2) {
	if (y1 > y2) {
	    System.err.println("Invalid Data" + y1 + " " + y2);
	}
	list.add(new YListElement(y1, +1));
	list.add(new YListElement(y2, -1));
    }
    public void addLeft(double x, double y1, double y2, 
			ArrayList l) {
	XListElement e = this.copy();
	e.x2 = x;
	this.x1 = x;
	e.add(y1, y2);
	l.add(e);
    }
    public void addRight(double x, double y1, double y2,
			 ArrayList l) {
	XListElement e = this.copy();
	System.out.println("Dividing at " + x);
	e.x1 = x;
	this.x2 = x;
	e.add(y1, y2);
	l.add(e);
    }
    public void addMid(double x1, double x2, double y1, double y2,
			 ArrayList l) {
	XListElement el = this.copy();
	XListElement er = this.copy();
	el.x2 = x1;
	er.x1 = x2;
	this.x1 = x1;
	this.x2 = x2;
	this.add(y1, y2);
	l.add(el);
	l.add(er);
    }
    XListElement copy() {
	XListElement e = new XListElement(this.x1, this.x2);
	e.list = (ArrayList)this.list.clone();
	return e;
    }
    double calc() {
	YListElement[] elements = new YListElement[0];
	elements = (YListElement[])list.toArray(elements);
	Arrays.sort(elements);
	int i;
	double ret = 0.0;
	int length = elements.length;
	int val = 0;
	double left = 0.0;
	System.out.println("Processing x between " + x1 + " " + x2);
	for (i = 0; i < length; i++) {
	    System.out.println(elements[i].y + ":" + elements[i].flag);
	    if (val == 0) {
		if (elements[i].flag == 1) {
		    left = elements[i].y;
		    val = 1;
		} else {
		    System.err.println("Error in calc: val is negative");
		}
	    } else {
		val += elements[i].flag;
		if (val == 0) {
		    ret += elements[i].y - left;
		}
	    }
	}
	if (val != 0) {
	    System.err.println("Error in calc: val = " + val);
	}
	return ret * (x2 - x1);
    }
}
class XList {
    ArrayList list = new ArrayList();
    double left = -1.0, right = -1.0;
    public void add(double x1, double x2, double y1, double y2) {
	if (left == -1.0) {
	    list.add(new XListElement(x1, x2, y1, y2));
	    left = x1;
	    right = x2;
	    return;
	}

	if (x1 < left) {
	    if (x2 < left) {
		list.add(new XListElement(x1, x2, y1, y2));
		list.add(new XListElement(x2, left));
		left = x1;
		return;
	    } else {
		list.add(new XListElement(x1, left, y1, y2));
	    }
	    left = x1;
	}
	if (x2 > right){
	    if (x1 > right) {
		list.add(new XListElement(x1, x2, y1, y2));
		list.add(new XListElement(right, x1));
		right = x2;
		return;
	    } else {
		list.add(new XListElement(right, x2, y1, y2));
	    }
	    right = x2;
	}

	ArrayList tlist = new ArrayList();
	Iterator i = list.iterator();
	while (i.hasNext()) {
	    XListElement e = (XListElement)i.next();
	    if (x1 > e.x1 && x2 < e.x2) {
		e.addMid(x1, x2, y1, y2, tlist);
		break;
	    }
	    if (e.x1 >= x1 && e.x1 < x2) {
		if (e.x2 <= x2) {
		    e.add(y1, y2);
		} else {
		    e.addLeft(x2, y1, y2, tlist);
		}
	    } else if (e.x2 > x1 && e.x2 <= x2) {
		e.addRight(x1, y1, y2, tlist);
	    }
	}
	list.addAll(tlist);
    }

    double calc() {
	double ret = 0.0;
	Iterator i = list.iterator();
	while (i.hasNext()) {
	    ret += ((XListElement)i.next()).calc();
	}
	return ret;
    }
}
