import java.io.*;
import java.util.*;

public class Numbergame {
    static final int MAX = 20;
    public static void main(String[] args) {
	try {
	    BufferedReader reader = 
		new BufferedReader(new FileReader("numbergame.in"));
	    BufferedWriter writer = 
		new BufferedWriter(new FileWriter("numbergame.out"));

	    int case_id = 0;
	    while (true) {
		case_id++;
		StringTokenizer tokenizer =
		    new StringTokenizer(reader.readLine());
		int n = Integer.parseInt(tokenizer.nextToken());
		if (n == 0)
		    break;

		Numbers nums = new Numbers();
		int i;
		for (i = 0; i < n; i++) {
		    int data =
			Integer.parseInt(tokenizer.nextToken());
		    nums.setUsable(data);
		}

		StringBuffer winMoves = new StringBuffer();
		boolean winnable = false;
		for (i = 2; i <= MAX; i++) {
		    if (nums.isUsable(i)) {
			if (choose((Numbers)nums.clone(), i)) {
			    winMoves.append(" " + i);
			    winnable = true;
			}
		    }
		}

		Numbers.printSize();

		writer.write("Test Case #" + case_id);
		writer.newLine();
		if (winnable) {
		    writer.write("The winning moves are:"
				 + winMoves.toString());
		} else {
		    writer.write("There's no winning move.");
		}
		writer.newLine(); writer.newLine();
		writer.flush();
	    }
	} catch (IOException e) {
	    System.err.println("I/O Error");
	}
    }
    static boolean choose(Numbers nums, int newNum) {
	nums.constProp(newNum);
	if (nums.isWinCase()) {
	    return true;
	} else if (nums.isLoseCase()) {
	    return false;
	}

	int i;
	for (i = 2; i <= MAX; i++) {
	    if (nums.isUsable(i)) {
		if (choose((Numbers)nums.clone(), i)) {
		    Numbers.addLoseCase(nums);
		    return false;
		}
	    }
	}

	Numbers.addWinCase(nums);
	return true;
    }
}
class Numbers {
    private boolean[] data = new boolean[Numbergame.MAX + 1];
    private static Set winCases = new HashSet();
    private static Set loseCases = new HashSet();

    static void printSize() {
	System.out.println(winCases.size() + " " + loseCases.size());
    }
    boolean isUsable(int i) {
	return data[i];
    }
    void setUsable(int i) {
	data[i] = true;
    }
    Numbers() {
	int i;
	for (i = 2; i <= Numbergame.MAX; i++)
	    data[i] = false;
    }
    static void addWinCase(Numbers nums) {
	winCases.add(nums);
    }
    static void addLoseCase(Numbers nums) {
	loseCases.add(nums);
    }
    boolean isWinCase() {
	return winCases.contains(this);
    }
    boolean isLoseCase() {
	return loseCases.contains(this);
    }
    public Object clone() {
	Numbers ret = new Numbers();
	ret.data = (boolean[])this.data.clone();
	return ret;
    }
    public int hashCode() {
	int code = 0;
	int i;
	for (i = 2; i <= Numbergame.MAX; i++) {
	    code = code * 2 + (data[i] ? 1 : 0);
	}
	return code;
    }
    public boolean equals(Object o) {
	int i;
	for (i = 2; i <= Numbergame.MAX; i++) {
	    if (data[i] != ((Numbers)o).data[i])
		return false;
	}
	return true;
    }
    void constProp(int newNum) {
	int i;
	for (i = 2; i <= Numbergame.MAX; i++) {
	    if (data[i] == false && i + newNum <= Numbergame.MAX) {
		data[i + newNum] = false;
	    } else if (i % newNum == 0) {
		data[i] = false;
	    }
	}
    }
}
