import java.io.*;
import java.util.*;

public class Ouroboros {
    static int n, exp;
    public static void main(String[] args) {
	try {
	    BufferedReader reader =
		new BufferedReader(new FileReader("ouroboros.in"));
	    BufferedWriter writer =
		new BufferedWriter(new FileWriter("ouroboros.out"));
	    HashMap datas = new HashMap();

	    while (true) {
		StringTokenizer tokenizer = 
		    new StringTokenizer(reader.readLine());
		n = Integer.parseInt(tokenizer.nextToken());
		int k = Integer.parseInt(tokenizer.nextToken());
		if (n == 0)
		    break;
		exp = 1 << n;

		BitSet data;
		int i;
		if (datas.containsKey(new Integer(n))) {
		    data = (BitSet)datas.get(new Integer(n));
		} else {
		    BitSet flag = new BitSet(exp);
		    data = new BitSet(exp);
		    for (i = 0; i < n; i++)
			data.clear(i);
		    flag.set(0);
		    if (search(data, flag, n, 0) == false) {
			System.err.println("Fail to calc ouroboros number");
		    }
		    datas.put(new Integer(n), data);
		}
		writer.write(Integer.toString(calcValue(data, k)));
		writer.newLine();
		writer.flush();
	    }
	} catch (IOException e) {
	    System.err.println("I/O Error");
	}
    }
    static int calcValue(BitSet data, int startIndex) {
	int ret = 0;
	int i;
	for (i = 0; i < n; i++)
	    ret = ret * 2 + (data.get((i + startIndex) % exp) ? 1 : 0);
	return ret;
    }
    static boolean search(BitSet data, BitSet flag, int index, int val) {
	if (index == exp) {
	    return check(flag, val);
	}

	int nextVal = (val * 2) % exp;
	if (flag.get(nextVal)) { // already occured
	    if (flag.get(nextVal+1))
		return false;
	    nextVal++;
	    data.set(index);
	    flag.set(nextVal);
	    if (search(data, flag, index + 1, nextVal)) {
		return true;
	    } else {
		flag.clear(nextVal);
		return false;
	    }
	} else {
	    data.clear(index);
	    flag.set(nextVal);

	    if (search(data, flag, index + 1, nextVal)) {
		return true;
	    } else {
		flag.clear(nextVal);
		nextVal++;
		flag.set(nextVal);
		data.set(index);
		if (search(data, flag, index + 1, nextVal)) {
		    return true;
		} else {
		    flag.clear(nextVal);
		    return false;
		}
	    }
	}
    }
    static boolean check(BitSet flag, int val) {
	int i;
	for (i = 0; i < n - 1; i++) {
	    val = (val * 2) % exp;
	    if (flag.get(val))
		return false;
	}
	return true;
    }
}
