import java.io.*;
import java.util.*;
import java.text.*;

public class Startup {
    static BufferedReader reader;
    public static void main(String[] args) {
	try {
	    reader = 
		new BufferedReader(new FileReader("startup.in"));
	    BufferedWriter writer =
		new BufferedWriter(new FileWriter("startup.out"));
	    DecimalFormat df = new DecimalFormat("0.00");

	    nextChar();
	    nextToken();
	    // search string
	    HashMap searchCount = new HashMap();
	    while (!token.equals("-")) {
		if (searchCount.containsKey(token)) {
		    int val = 
			((Integer)searchCount.get(token)).intValue();
		    searchCount.put(token, new Integer(val + 1));
		} else {
		    searchCount.put(token, new Integer(1));
		}
		nextToken();
	    }
	    nextToken();

	    // documents
	    while (true) {
		System.out.println("\nNext Document");
		HashMap scoreTable = new HashMap();
		while (!token.equals("-")) {
		    if (searchCount.containsKey(token)) {
			int val =
			((Integer)searchCount.get(token)).intValue();
			if (scoreTable.containsKey(token)) {
			    int oldscore = 
				((Integer)scoreTable.get(token))
				.intValue();
			    scoreTable.put(
				token, new Integer(oldscore + val));
			} else {
			    scoreTable.put(token, new Integer(val));
			}
		    }
		    nextToken();
		}
		nextToken();
		
		// calc score
		Iterator i = scoreTable.values().iterator();
		double score = 0.0;
		while (i.hasNext()) {
		    score += 
			Math.sqrt(((Integer)i.next()).intValue());
		}
		writer.write(df.format(score) + "\n");
		writer.flush();

		if (token.equals("-"))
		    break;
	    }
	} catch (IOException e) {
	    System.err.println("IOException");
	}
    }
    static String token;

    static String line;
    static int length = 0;
    static int index = 0;
    static char ch;
    static void nextChar() throws IOException{
	if (length == index) {
	    line = (reader.readLine() + " ").toLowerCase();
	    if (line.equals("---------- ")) {
		index = length = 0;
		ch = '\0';
		return;
	    }
	    length = line.length();
	    index = 0;
	}
	ch = line.charAt(index++);
    }
    static void nextToken() throws IOException{
	StringBuffer buffer = new StringBuffer();
	boolean flag = true;
	while (flag) {
	    while (ch == ' ')
		nextChar();
	    if (ch == '\0') {
		token = "-";
		nextChar();
		System.out.println("-");
		return;
	    }
	    while (ch != ' ') {
		if ((ch >= '0' && ch <= '9') ||
		    (ch >= 'a' && ch <= 'z')) {
		    buffer.append(ch);
		    flag = false;
		}
		nextChar();
	    }
	}
	token = buffer.toString();
	System.out.println(token);
    }
}
